-- author: DD ModPassion
-- date: 04.02.2020
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
attacherJointControlPlow = {} function attacherJointControlPlow.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(AttacherJointControl, specializations) end function attacherJointControlPlow.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "loadInputAttacherJoint", attacherJointControlPlow.loadInputAttacherJoint) SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsLowered", attacherJointControlPlow.getIsLowered) end function attacherJointControlPlow.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", attacherJointControlPlow) SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", attacherJointControlPlow) SpecializationUtil.registerEventListener(vehicleType, "saveToXMLFile", attacherJointControlPlow) SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", attacherJointControlPlow) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", attacherJointControlPlow) SpecializationUtil.registerEventListener(vehicleType, "onAIImplementStart", attacherJointControlPlow) SpecializationUtil.registerEventListener(vehicleType, "onAIImplementEnd", attacherJointControlPlow) end function attacherJointControlPlow:onLoad(savegame) local spec = self.spec_attacherJointControl spec.attacherVehicle = nil spec.inputJointDescIndex = nil spec.jointDescIndex = nil local key = string.format("vehicle.attachable.inputAttacherJoints.inputAttacherJoint(%d)", 0) local jointTypeStr = getXMLString(self.xmlFile, key .. "#jointType") spec.jointType = nil if jointTypeStr ~= nil then spec.jointType = AttacherJoints.jointTypeNameToInt[jointTypeStr] end local lowerDistanceToGround = Utils.getNoNil(getXMLFloat(self.xmlFile, key..".distanceToGround#lower"), 0.7) local upperDistanceToGround = Utils.getNoNil(getXMLFloat(self.xmlFile, key..".distanceToGround#upper"), 1.0) spec.spostamento = upperDistanceToGround - lowerDistanceToGround if #spec.controls == 0 and spec.jointType == AttacherJoints.JOINTTYPE_IMPLEMENT and spec.spostamento > 0 then local control = {} local controlFunc = "controlAttacherJointHeight" if controlFunc ~= nil and self[controlFunc] ~= nil then control.func = self[controlFunc] if control.func == self.controlAttacherJointHeight then spec.heightController = control end end local actionBindingName = "AXIS_TOOL_PLOW" if actionBindingName ~= nil and InputAction[actionBindingName] ~= nil then control.controlAction = InputAction[actionBindingName] end local iconName = "IMPLEMENT_ATTACHER_TRANS" if InputHelpElement.AXIS_ICON[iconName] == nil then iconName = (self.customEnvironment or "") .. iconName end control.axisActionIcon = iconName control.invertAxis = true control.mouseSpeedFactor = 0.5 control.moveAlpha = 0 spec.nameToControl[actionBindingName] = control table.insert(spec.controls, control) if self.isClient then spec.lastMoveTime = 0 spec.samples = {} spec.samples.hydraulic = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.cylindered.sounds", "hydraulic", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self) end spec.jointDesc = nil spec.dirtyFlag = self:getNextDirtyFlag() end spec.controlloAvvio = false end function attacherJointControlPlow:onPostLoad(savegame) local spec = self.spec_attacherJointControl if savegame ~= nil and not savegame.resetVehicles then spec.controlloAvvio = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key..".attacherJointControlPlow#controlloAvvio"), spec.controlloAvvio) end end function attacherJointControlPlow:saveToXMLFile(xmlFile, key, usedModNames) local spec = self.spec_attacherJointControl local controlloAvvio = false if self:getAttacherVehicle() then controlloAvvio = true end setXMLBool(xmlFile, key.."#controlloAvvio", controlloAvvio) end function attacherJointControlPlow:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex) local spec = self.spec_attacherJointControl spec.attacherVehicle = attacherVehicle spec.inputJointDescIndex = inputJointDescIndex spec.jointDescIndex = jointDescIndex end function attacherJointControlPlow:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_attacherJointControl if spec.heightController then local showText = spec.jointDesc ~= nil if showText then local angle = spec.maxTiltAngle * spec.controls[1].moveAlpha - 0.5 spec.jointDesc.upperRotationOffset = spec.jointDesc.upperRotationOffsetBackup + angle spec.jointDesc.lowerRotationOffset = spec.jointDesc.lowerRotationOffsetBackup + angle spec = self.spec_attachable if self:getControlAttacherJointDirection() then if spec.lowerAnimation ~= nil and not self:getIsAnimationPlaying(spec.lowerAnimation) and self:getAnimationTime(spec.lowerAnimation) > 0 then self:playAnimation(spec.lowerAnimation, -1, self:getAnimationTime(spec.lowerAnimation), true) end else if spec.lowerAnimation ~= nil and not self:getIsAnimationPlaying(spec.lowerAnimation) and self:getAnimationTime(spec.lowerAnimation) < 1 then self:playAnimation(spec.lowerAnimation, 1, self:getAnimationTime(spec.lowerAnimation), true) end end end end if spec.controlloAvvio and self.isServer then local attacherVehicle = self:getAttacherVehicle() if attacherVehicle ~= nil then attacherVehicle:detachImplementByObject(self) end spec.controlloAvvio = false end end function attacherJointControlPlow:onAIImplementStart() local spec = self.spec_attacherJointControl local inputAttacherJoints = self:getInputAttacherJoints() inputAttacherJoints[spec.inputJointDescIndex].isControllable = false if spec.jointDesc ~= nil then spec.jointDesc.allowsLowering = spec.jointDesc.allowsLoweringBackup spec.jointDesc.upperRotationOffset = spec.jointDesc.upperRotationOffsetBackup spec.jointDesc.lowerRotationOffset = spec.jointDesc.lowerRotationOffsetBackup spec.jointDesc = nil end end function attacherJointControlPlow:onAIImplementEnd() local spec = self.spec_attacherJointControl local inputAttacherJoints = self:getInputAttacherJoints() inputAttacherJoints[spec.inputJointDescIndex].isControllable = true if inputAttacherJoints[spec.inputJointDescIndex] ~= nil and inputAttacherJoints[spec.inputJointDescIndex].isControllable then local attacherJoints = spec.attacherVehicle:getAttacherJoints() local jointDesc = attacherJoints[spec.jointDescIndex] jointDesc.allowsLoweringBackup = jointDesc.allowsLowering jointDesc.allowsLowering = false jointDesc.upperRotationOffsetBackup = jointDesc.upperRotationOffset jointDesc.lowerRotationOffsetBackup = jointDesc.lowerRotationOffset spec.jointDesc = jointDesc for _, control in ipairs(spec.controls) do control.moveAlpha = control.func(self) end spec.heightTargetAlpha = spec.jointDesc.upperAlpha self:requestActionEventUpdate() end end function attacherJointControlPlow:loadInputAttacherJoint(superFunc, xmlFile, key, inputAttacherJoint, i) if not superFunc(self, xmlFile, key, inputAttacherJoint, i) then return false end inputAttacherJoint.isControllable = Utils.getNoNil(getXMLBool(xmlFile, key .. "#isControllable"), true) return true end function attacherJointControlPlow:getIsLowered(superFunc, default) local spec = self.spec_foldable if spec ~= nil then if self:getIsFoldMiddleAllowed() then if spec.foldMiddleAnimTime ~= nil and spec.foldMiddleInputButton ~= nil then if spec.foldMoveDirection ~= 0 then if spec.foldMiddleDirection > 0 then if spec.foldAnimTime < spec.foldMiddleAnimTime + 0.01 then return spec.foldMoveDirection < 0 and spec.moveToMiddle ~= true end else if spec.foldAnimTime > spec.foldMiddleAnimTime - 0.01 then return spec.foldMoveDirection > 0 and spec.moveToMiddle ~= true end end else if spec.foldMiddleDirection > 0 and spec.foldAnimTime < 0.01 then return true elseif spec.foldMiddleDirection < 0 and math.abs(1.0 - spec.foldAnimTime) < 0.01 then return true end end return false end end end spec = self.spec_attacherJointControl if spec.heightController then local showText = spec.jointDesc ~= nil if showText then spec = self.spec_attachable if self:getControlAttacherJointDirection() then if spec.lowerAnimation ~= nil and not self:getIsAnimationPlaying(spec.lowerAnimation) and self:getAnimationTime(spec.lowerAnimation) > 0 then self:playAnimation(spec.lowerAnimation, -1, self:getAnimationTime(spec.lowerAnimation), true) end return false else if spec.lowerAnimation ~= nil and not self:getIsAnimationPlaying(spec.lowerAnimation) and self:getAnimationTime(spec.lowerAnimation) < 1 then self:playAnimation(spec.lowerAnimation, 1, self:getAnimationTime(spec.lowerAnimation), true) end return true end end end return superFunc(self, default) end